/****************************************************************
 *                                                              *
 *                        I C A O   M a p  -                    *
 *                                                              *
 *             A n   A v i a t i o n   U t i l i t y            *
 *                                                              *
 *                                                              *
 *            Copyright (C) 1993, 1994  Martin Pauly            *
 *                                                              *
 *   This file may be freely distributed only if it includes    *
 *                the above copyright notice.                   *
 *                                                              *
 ****************************************************************/

#ifndef GPSSIM_H
#define GPSSIM_H

#include "coord.h"


extern char gps_date[20];



typedef struct log_record {
  LOCATION loc;
  int time;
  int alt;
  int speed;
  int track;
  int status;    /* 0=cruise, 1=climb */
  int x,y;       /* screen coordinates when displayed */
} LOGRECORD;

extern LOGRECORD log_points[];
extern int log_numpoints;         /* 0 = no valid log loaded */
extern int log_visible;

extern int log_take_off_index;
extern int log_landing_index;

extern int log_rate_of_circling;    /* 0-100 */

void gps_read_log (char *filename);
void gps_draw_log(void);
void log_show_baro(void);
void baro_mark_time (int time);
void gps_read_log_dialog(void);
void adjust_map_for_log(void);
void gps_evaluate(void);
void flatten_altitude(void);


#endif
